
Ruby - Bug #20997

YJIT panic assertion `left == right` failed: leave instruction expects stack size 1, but was: 2

01/02/2025 03:52 PM - bdewater (Bart de Water)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 3.4.1 Backport: 3.1: DONTNEED, 3.2: DONE, 3.3:

DONE, 3.4: DONE

Description

I tried upgrading our Rails app from Ruby 3.3.6 to 3.4.1 and our test suite failed with the following panic error on our Linux CI

runners. In case it matters, we use https://runs-on.com/ instead of GitHub's runners and the AMI name is

runs-on-v2.2-ubuntu22-full-x64-20241216080634. It also happens on my Macbook (macOS Sequioa 15.2, rustc 1.82.0 (f6e511eec

2024-10-15) (Homebrew)).

The code that looks related to the panic is from the Heya gem: 

https://github.com/honeybadger-io/heya/blob/v0.12.0/lib/heya/campaigns/base.rb#L21

2024-12-31T18:16:11.8722381Z Running 8655 tests in parallel using 16 processes

2024-12-31T18:16:42.8924916Z ruby: YJIT has panicked. More info to follow...

2024-12-31T18:16:42.8925406Z thread '<unnamed>' panicked at ./yjit/src/codegen.rs:9862:5:

2024-12-31T18:16:42.8926247Z assertion `left == right`

 failed: leave instruction expects stack size 1, but was: 2

2024-12-31T18:16:42.8926553Z   left: 1

2024-12-31T18:16:42.8926718Z  right: 2

2024-12-31T18:16:42.8926881Z stack backtrace:

2024-12-31T18:16:43.0162127Z    0: rust_begin_unwind

2024-12-31T18:16:43.0162776Z              at /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/libra

ry/std/src/panicking.rs:665:5

2024-12-31T18:16:43.0163216Z    1: core::panicking::panic_fmt

2024-12-31T18:16:43.0163615Z              at /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/libra

ry/core/src/panicking.rs:74:14

2024-12-31T18:16:43.0163998Z    2: core::panicking::assert_failed_inner

2024-12-31T18:16:43.0164283Z    3: core::panicking::assert_failed

2024-12-31T18:16:43.0164661Z              at /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/libra

ry/core/src/panicking.rs:367:5

2024-12-31T18:16:43.0165387Z    4: yjit::codegen::gen_leave

2024-12-31T18:16:43.0165731Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/codegen.rs:9862:5

2024-12-31T18:16:43.0173845Z    5: yjit::codegen::gen_single_block

2024-12-31T18:16:43.0175844Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/codegen.rs:1387:22

2024-12-31T18:16:43.0187264Z    6: yjit::core::gen_block_series_body

2024-12-31T18:16:43.0187792Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/core.rs:3129:22

2024-12-31T18:16:43.0188214Z    7: yjit::core::gen_block_series

2024-12-31T18:16:43.0188587Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/core.rs:3066:18

2024-12-31T18:16:43.0198226Z    8: yjit::core::branch_stub_hit_body

2024-12-31T18:16:43.0206832Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/core.rs:3604:17

2024-12-31T18:16:43.0207314Z    9: yjit::core::branch_stub_hit::{{closure}}::{{closure}}

2024-12-31T18:16:43.0207728Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/core.rs:3493:36

2024-12-31T18:16:43.0208094Z   10: yjit::stats::with_compile_time

2024-12-31T18:16:43.0208443Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/stats.rs:1084:15

2024-12-31T18:16:43.0208853Z   11: yjit::core::branch_stub_hit::{{closure}}

2024-12-31T18:16:43.0209396Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/core.rs:3493:13

2024-12-31T18:16:43.0211884Z   12: std::panicking::try::do_call
2024-12-31T18:16:43.0218429Z              at /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/libra

ry/std/src/panicking.rs:557:40

2024-12-31T18:16:43.0219965Z   13: std::panicking::try

2024-12-31T18:16:43.0222127Z              at /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/libra

ry/std/src/panicking.rs:520:19

2024-12-31T18:16:43.0222557Z   14: std::panic::catch_unwind

2024-12-31T18:16:43.0224190Z              at /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/libra

ry/std/src/panic.rs:358:14

2024-12-31T18:16:43.0224574Z   15: yjit::cruby::with_vm_lock

2024-12-31T18:16:43.0226910Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/cruby.rs:688:21

2024-12-31T18:16:43.0227401Z   16: yjit::core::branch_stub_hit

2024-12-31T18:16:43.0227748Z              at /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1

/yjit/src/core.rs:3492:9

2024-12-31T18:16:43.0229724Z   17: <unknown>

2024-12-31T18:16:43.0230136Z note: Some details are omitted, run with `RUST_BACKTRACE=full` for 

a verbose backtrace.

2024-12-31T18:16:43.0232990Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/base.rb:21: [BUG] YJIT: panicked at ./yjit/src/codegen.rs:9862:5:

2024-12-31T18:16:43.0234208Z assertion `left == right`

 failed: leave instruction expects stack size 1, but was: 2

2024-12-31T18:16:43.0234555Z   left: 1

2024-12-31T18:16:43.0235746Z  right: 2at") Vq

2024-12-31T18:16:43.0236087Z ruby 3.4.1 (2024-12-25 revision 48d4efcb85) +YJIT +PRISM [x86_64-linu

x]

2024-12-31T18:16:43.0236298Z 

2024-12-31T18:16:43.0239841Z -- Control frame information ----------------------------------------

-------

2024-12-31T18:16:43.0240711Z c:0073 p:0006 s:0456 e:000453 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/base.rb:21 [FINISH]

2024-12-31T18:16:43.0243393Z c:0072 p:0016 s:0449 e:000445 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/globalid-1.2.1/lib/global_id/uri/gid.rb:73

2024-12-31T18:16:43.0245173Z c:0071 p:0039 s:0439 e:000437 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/globalid-1.2.1/lib/global_id/global_id.rb:14

2024-12-31T18:16:43.0247112Z c:0070 p:0011 s:0430 e:000429 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/globalid-1.2.1/lib/global_id/identification.rb:38 [FINISH]

2024-12-31T18:16:43.0248073Z c:0069 p:0005 s:0425 e:000424 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/base.rb:26

2024-12-31T18:16:43.0248987Z c:0068 p:0009 s:0421 e:000418 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/queries.rb:16

2024-12-31T18:16:43.0249780Z c:0067 p:0043 s:0413 e:000412 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/scheduler.rb:65 [FINISH]

2024-12-31T18:16:43.0250919Z c:0066 p:0016 s:0409 e:000408 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/connection_adapters/abstr [F

INISH]

2024-12-31T18:16:43.0251689Z c:0065 p:---- s:0404 e:000403 CFUNC  :handle_interrupt

2024-12-31T18:16:43.0252484Z c:0064 p:0015 s:0399 e:000398 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/concurrency/load_interl [F

INISH]

2024-12-31T18:16:43.0253416Z c:0063 p:---- s:0396 e:000395 CFUNC  :handle_interrupt

2024-12-31T18:16:43.0254183Z c:0062 p:0007 s:0391 e:000390 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/concurrency/load_interl

2024-12-31T18:16:43.0255232Z c:0061 p:0008 s:0386 e:000385 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/connection_adapters/abstr

2024-12-31T18:16:43.0256487Z c:0060 p:0047 s:0379 e:000378 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/connection_adapters/abstr [F

INISH]

2024-12-31T18:16:43.0257509Z c:0059 p:0011 s:0370 e:000369 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/transactions.rb:234 [FINISH]

2024-12-31T18:16:43.0258486Z c:0058 p:0034 s:0366 e:000365 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/connection_adapters/abstr

2024-12-31T18:16:43.0259498Z c:0057 p:0011 s:0358 e:000357 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/connection_handling.rb:29 [F

INISH]

2024-12-31T18:16:43.0260585Z c:0056 p:0004 s:0351 e:000350 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/transactions.rb:233

2024-12-31T18:16:43.0261643Z c:0055 p:0005 s:0345 e:000344 METHOD /home/runner/_work/thatch/thatch
/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/scheduler.rb:60

2024-12-31T18:16:43.0262438Z c:0054 p:0072 s:0338 e:000337 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/scheduler.rb:38 [FINISH]

2024-12-31T18:16:43.0263098Z c:0053 p:0027 s:0331 e:000330 METHOD <internal:array>:228

2024-12-31T18:16:43.0263861Z c:0052 p:0008 s:0325 e:000324 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/relation/batches.rb:82

2024-12-31T18:16:43.0264848Z c:0051 p:0006 s:0321 e:000320 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/relation/batches.rb:158

2024-12-31T18:16:43.0265990Z c:0050 p:0158 s:0317 e:000316 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/relation/batches.rb:402 [FIN

ISH]

2024-12-31T18:16:43.0266697Z c:0049 p:0017 s:0306 e:000305 METHOD <internal:kernel>:168

2024-12-31T18:16:43.0267440Z c:0048 p:0063 s:0301 e:000300 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/relation/batches.rb:378

2024-12-31T18:16:43.0268392Z c:0047 p:0143 s:0285 e:000284 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/relation/batches.rb:269

2024-12-31T18:16:43.0269485Z c:0046 p:0050 s:0270 e:000269 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/relation/batches.rb:157

2024-12-31T18:16:43.0270444Z c:0045 p:0028 s:0259 e:000258 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activerecord-7.2.2.1/lib/active_record/relation/batches.rb:81

2024-12-31T18:16:43.0271509Z c:0044 p:0017 s:0248 e:000247 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/scheduler.rb:21

2024-12-31T18:16:43.0272384Z c:0043 p:0125 s:0242 E:000cd0 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/base.rb:53

2024-12-31T18:16:43.0273173Z c:0042 p:0024 s:0228 e:000227 METHOD /home/runner/_work/thatch/thatch

/app/campaigns/application_campaign.rb:20 [FINISH]

2024-12-31T18:16:43.0273716Z c:0041 p:---- s:0219 e:000218 CFUNC  :bind_call

2024-12-31T18:16:43.0274464Z c:0040 p:0063 s:0212 e:000211 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/sorbet-runtime-0.5.11708/lib/types/private/methods/call_validati

2024-12-31T18:16:43.0275675Z c:0039 p:0013 s:0201 e:000200 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/sorbet-runtime-0.5.11708/lib/types/private/methods/call_validati

2024-12-31T18:16:43.0276550Z c:0038 p:0024 s:0195 e:000194 METHOD /home/runner/_work/thatch/thatch

/app/campaigns/enrollment_event_campaign.rb:20 [FINISH]

2024-12-31T18:16:43.0277001Z c:0037 p:---- s:0186 e:000185 CFUNC  :bind_call

2024-12-31T18:16:43.0277726Z c:0036 p:0105 s:0180 e:000179 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/sorbet-runtime-0.5.11708/lib/types/private/methods/call_validati

2024-12-31T18:16:43.0278719Z c:0035 p:0126 s:0169 e:000168 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/sorbet-runtime-0.5.11708/lib/types/private/methods/_methods.rb:2

2024-12-31T18:16:43.0279639Z c:0034 p:0012 s:0162 e:000161 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/heya-0.12.0/lib/heya/campaigns/base.rb:101

2024-12-31T18:16:43.0280596Z c:0033 p:0069 s:0154 e:000153 BLOCK  /home/runner/_work/thatch/thatch

/test/operations/enrollments/remove_enrollment_event_from_mailer_campaign_test.rb:20 [FINISH]

2024-12-31T18:16:43.0281359Z c:0032 p:---- s:0151 e:000150 CFUNC  :instance_eval

2024-12-31T18:16:43.0282063Z c:0031 p:0012 s:0147 e:000146 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest/spec.rb:195 [FINISH]

2024-12-31T18:16:43.0282922Z c:0030 p:0005 s:0143 e:000142 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest/test.rb:91

2024-12-31T18:16:43.0283428Z c:0029 p:0027 s:0139 e:000138 METHOD <internal:array>:228

2024-12-31T18:16:43.0283975Z c:0028 p:0005 s:0133 e:000132 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest/test.rb:90

2024-12-31T18:16:43.0284711Z c:0027 p:0002 s:0130 e:000129 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest/test.rb:190 [FINISH]

2024-12-31T18:16:43.0285449Z c:0026 p:0004 s:0125 e:000124 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest/test.rb:89

2024-12-31T18:16:43.0286145Z c:0025 p:0008 s:0122 e:000121 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest.rb:368

2024-12-31T18:16:43.0287030Z c:0024 p:0004 s:0117 e:000116 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest/test.rb:88 [FINISH]

2024-12-31T18:16:43.0287852Z c:0023 p:0040 s:0113 e:000112 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-reporters-1.7.1/lib/minitest/reporters.rb:48 [FINISH]

2024-12-31T18:16:43.0288719Z c:0022 p:0006 s:0106 e:000105 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/executor/test_helper.rb

2024-12-31T18:16:43.0289594Z c:0021 p:0012 s:0103 e:000102 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/execution_wrapper.rb:10

2024-12-31T18:16:43.0290605Z c:0020 p:0009 s:0098 e:000097 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/executor/test_helper.rb

2024-12-31T18:16:43.0291669Z c:0019 p:0008 s:0093 e:000092 METHOD /home/runner/_work/thatch/thatch
/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest.rb:1208

2024-12-31T18:16:43.0296468Z c:0018 p:0008 s:0086 e:000085 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/testing/parallelization

2024-12-31T18:16:43.0303560Z c:0017 p:0022 s:0083 e:000082 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest.rb:472 [FINISH]

2024-12-31T18:16:43.0304607Z c:0016 p:0014 s:0075 e:000074 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest.rb:459

2024-12-31T18:16:43.0305812Z c:0015 p:0049 s:0069 e:000068 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/testing/parallelization

2024-12-31T18:16:43.0306694Z c:0014 p:0011 s:0060 e:000059 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/testing/parallelization

2024-12-31T18:16:43.0307860Z c:0013 p:0039 s:0055 e:000054 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/testing/parallelization [F

INISH]

2024-12-31T18:16:43.0308573Z c:0012 p:---- s:0052 e:000051 CFUNC  :fork

2024-12-31T18:16:43.0309317Z c:0011 p:0004 s:0048 e:000047 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/testing/parallelization

2024-12-31T18:16:43.0310325Z c:0010 p:0011 s:0044 e:000043 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/testing/parallelization [F

INISH]

2024-12-31T18:16:43.0310972Z c:0009 p:---- s:0040 e:000039 IFUNC 

2024-12-31T18:16:43.0311455Z c:0008 p:0024 s:0037 e:000035 METHOD <internal:numeric>:257 [FINISH]

2024-12-31T18:16:43.0311769Z c:0007 p:---- s:0031 e:000030 CFUNC  :each

2024-12-31T18:16:43.0312031Z c:0006 p:---- s:0028 e:000027 CFUNC  :map

2024-12-31T18:16:43.0312754Z c:0005 p:0008 s:0024 e:000023 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/testing/parallelization

2024-12-31T18:16:43.0313863Z c:0004 p:0023 s:0020 e:000019 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/activesupport-7.2.2.1/lib/active_support/testing/parallelize_exe

2024-12-31T18:16:43.0314754Z c:0003 p:0128 s:0016 e:000015 METHOD /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest.rb:285

2024-12-31T18:16:43.0315662Z c:0002 p:0045 s:0008 E:001ab0 BLOCK  /home/runner/_work/thatch/thatch

/vendor/bundle/ruby/3.4.0/gems/minitest-5.25.4/lib/minitest.rb:86 [FINISH]

2024-12-31T18:16:43.0316270Z c:0001 p:0000 s:0003 E:000760 DUMMY  [FINISH]

2024-12-31T18:16:43.0316418Z 

2024-12-31T18:16:43.0316638Z -- Ruby level backtrace information ---------------------------------

-------

2024-12-31T18:16:43.0317487Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest.rb:86:in 'block in autorun'

2024-12-31T18:16:43.0318257Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest.rb:285:in 'run'

2024-12-31T18:16:43.0325400Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelize_executor.rb:19:in 'start'

2024-12-31T18:16:43.0326382Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization.rb:36:in 'start'

2024-12-31T18:16:43.0327205Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization.rb:36:in 'map'

2024-12-31T18:16:43.0328065Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization.rb:36:in 'each'

2024-12-31T18:16:43.0328579Z <internal:numeric>:257:in 'times'

2024-12-31T18:16:43.0329216Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization.rb:37:in 'block in start'

2024-12-31T18:16:43.0330090Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization/worker.rb:15:in 'start'

2024-12-31T18:16:43.0331005Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization/worker.rb:15:in 'fork'

2024-12-31T18:16:43.0335908Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization/worker.rb:27:in 'block in start'

2024-12-31T18:16:43.0337217Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization/worker.rb:38:in 'work_from_queue'

2024-12-31T18:16:43.0338146Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization/worker.rb:49:in 'perform_job'

2024-12-31T18:16:43.0338969Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest.rb:459:in 'with_info_handler'

2024-12-31T18:16:43.0343017Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest.rb:472:in 'on_signal'

2024-12-31T18:16:43.0344480Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/testing/parallelization/worker.rb:50:in 'block in perform_job'
2024-12-31T18:16:43.0345329Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest.rb:1208:in 'run_one_method'

2024-12-31T18:16:43.0346128Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/executor/test_helper.rb:5:in 'run'

2024-12-31T18:16:43.0346920Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/execution_wrapper.rb:104:in 'perform'

2024-12-31T18:16:43.0347778Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/executor/test_helper.rb:5:in 'block in run'

2024-12-31T18:16:43.0348614Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-reporters-1.7.1/lib/minitest/reporters.rb:48:in 'run_with_hooks'

2024-12-31T18:16:43.0349305Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest/test.rb:88:in 'run'

2024-12-31T18:16:43.0349941Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest.rb:368:in 'time_it'

2024-12-31T18:16:43.0350597Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest/test.rb:89:in 'block in run'

2024-12-31T18:16:43.0351449Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest/test.rb:190:in 'capture_exceptions'

2024-12-31T18:16:43.0352180Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest/test.rb:90:in 'block (2 levels) in run'

2024-12-31T18:16:43.0352900Z <internal:array>:228:in 'each'

2024-12-31T18:16:43.0354667Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest/test.rb:91:in 'block (3 levels) in run'

2024-12-31T18:16:43.0355521Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest/spec.rb:195:in 'block in before'

2024-12-31T18:16:43.0356320Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/minite

st-5.25.4/lib/minitest/spec.rb:195:in 'instance_eval'

2024-12-31T18:16:43.0357275Z /home/runner/_work/thatch/thatch/test/operations/enrollments/remove_e

nrollment_event_from_mailer_campaign_test.rb:20:in 'block (2 levels) in <class:RemoveEnrollmentEve

ntFromMailerCampaignTest>'

2024-12-31T18:16:43.0358137Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/base.rb:101:in 'add'

2024-12-31T18:16:43.0358932Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/sorbet

-runtime-0.5.11708/lib/types/private/methods/_methods.rb:277:in 'block in _on_method_added'

2024-12-31T18:16:43.0359814Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/sorbet

-runtime-0.5.11708/lib/types/private/methods/call_validation.rb:278:in 'validate_call'

2024-12-31T18:16:43.0360675Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/sorbet

-runtime-0.5.11708/lib/types/private/methods/call_validation.rb:278:in 'bind_call'

2024-12-31T18:16:43.0361456Z /home/runner/_work/thatch/thatch/app/campaigns/enrollment_event_campa

ign.rb:20:in 'add'

2024-12-31T18:16:43.0363971Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/sorbet

-runtime-0.5.11708/lib/types/private/methods/call_validation.rb:117:in 'block in create_validator_

slow_skip_block_type'

2024-12-31T18:16:43.0366075Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/sorbet

-runtime-0.5.11708/lib/types/private/methods/call_validation.rb:175:in 'validate_call_skip_block_t

ype'

2024-12-31T18:16:43.0368107Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/sorbet

-runtime-0.5.11708/lib/types/private/methods/call_validation.rb:175:in 'bind_call'

2024-12-31T18:16:43.0368803Z /home/runner/_work/thatch/thatch/app/campaigns/application_campaign.r

b:20:in 'add'

2024-12-31T18:16:43.0369387Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/base.rb:53:in 'add'

2024-12-31T18:16:43.0370033Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/scheduler.rb:21:in 'run'

2024-12-31T18:16:43.0370759Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/relation/batches.rb:81:in 'find_each'

2024-12-31T18:16:43.0373867Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/relation/batches.rb:157:in 'find_in_batches'

2024-12-31T18:16:43.0374766Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/relation/batches.rb:269:in 'in_batches'

2024-12-31T18:16:43.0377392Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/relation/batches.rb:378:in 'batch_on_unloaded_relation'

2024-12-31T18:16:43.0377943Z <internal:kernel>:168:in 'loop'

2024-12-31T18:16:43.0378581Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/relation/batches.rb:402:in 'block in batch_on_unloaded_relation'

2024-12-31T18:16:43.0379484Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/relation/batches.rb:158:in 'block in find_in_batches'
2024-12-31T18:16:43.0380328Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/relation/batches.rb:82:in 'block in find_each'

2024-12-31T18:16:43.0380819Z <internal:array>:228:in 'each'

2024-12-31T18:16:43.0381689Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/scheduler.rb:38:in 'block in run'

2024-12-31T18:16:43.0382401Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/scheduler.rb:60:in 'process'

2024-12-31T18:16:43.0383156Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/transactions.rb:233:in 'transaction'

2024-12-31T18:16:43.0383976Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/connection_handling.rb:296:in 'with_connection'

2024-12-31T18:16:43.0384896Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/connection_adapters/abstract/connection_pool.rb:415:in 'with_conn

ection'

2024-12-31T18:16:43.0385826Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/transactions.rb:234:in 'block in transaction'

2024-12-31T18:16:43.0386756Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/connection_adapters/abstract/database_statements.rb:361:in 'trans

action'

2024-12-31T18:16:43.0387735Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/connection_adapters/abstract/transaction.rb:613:in 'within_new_tr

ansaction'

2024-12-31T18:16:43.0388699Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/concurrency/load_interlock_aware_monitor.rb:19:in 'synchronize'

2024-12-31T18:16:43.0389640Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/concurrency/load_interlock_aware_monitor.rb:19:in 'handle_inter

rupt'

2024-12-31T18:16:43.0390758Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/concurrency/load_interlock_aware_monitor.rb:23:in 'block in syn

chronize'

2024-12-31T18:16:43.0391852Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

support-7.2.2.1/lib/active_support/concurrency/load_interlock_aware_monitor.rb:23:in 'handle_inter

rupt'

2024-12-31T18:16:43.0393304Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/active

record-7.2.2.1/lib/active_record/connection_adapters/abstract/transaction.rb:616:in 'block in with

in_new_transaction'

2024-12-31T18:16:43.0394199Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/scheduler.rb:65:in 'block in process'

2024-12-31T18:16:43.0395230Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/queries.rb:16:in 'block in <module:Queries>'

2024-12-31T18:16:43.0395993Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/base.rb:26:in 'gid'

2024-12-31T18:16:43.0396884Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/global

id-1.2.1/lib/global_id/identification.rb:38:in 'to_global_id'

2024-12-31T18:16:43.0397595Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/global

id-1.2.1/lib/global_id/global_id.rb:14:in 'create'

2024-12-31T18:16:43.0398244Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/global

id-1.2.1/lib/global_id/uri/gid.rb:73:in 'create'

2024-12-31T18:16:43.0398887Z /home/runner/_work/thatch/thatch/vendor/bundle/ruby/3.4.0/gems/heya-0

.12.0/lib/heya/campaigns/base.rb:21:in 'name'

2024-12-31T18:16:43.0399188Z 

2024-12-31T18:16:43.0399412Z -- Threading information --------------------------------------------

-------

2024-12-31T18:16:43.0399716Z Total ractor count: 1

2024-12-31T18:16:43.0399949Z Ruby thread count for this ractor: 4

2024-12-31T18:16:43.0400094Z 

2024-12-31T18:16:43.0400301Z -- C level backtrace information ------------------------------------

-------

2024-12-31T18:16:43.2171992Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(rb_print_backt

race+0x8) [0x7fd6d4751a90] /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1/vm_dump.c:823

2024-12-31T18:16:43.2173418Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(rb_vm_bugrepor

t) /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1/vm_dump.c:1155

2024-12-31T18:16:43.2174286Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(rb_bug_without

_die_internal+0x6f) [0x7fd6d4455bc5] /tmp/ruby-build.20241225190136.2100.HNqbT3/ruby-3.4.1/error.c

:1097

2024-12-31T18:16:43.2175068Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(rb_bug) /tmp/r

uby-build.20241225190136.2100.HNqbT3/ruby-3.4.1/error.c:1115
2024-12-31T18:16:43.2175741Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4({closure#0}+0x

2bc) [0x7fd6d48b5f6c] yjit/src/yjit.rs:122

2024-12-31T18:16:43.2176831Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(call<(&std::pa

nic::PanicHookInfo), (dyn core::ops::function::Fn<(&std::panic::PanicHookInfo), Output=()> + core:

:marker::Send + core::marker::Sync), alloc::alloc::Global>+0x3) [0x7fd6d481f60d] alloc/src/boxed.r

s:2468

2024-12-31T18:16:43.2177877Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(rust_panic_wit

h_hook) std/src/panicking.rs:809

2024-12-31T18:16:43.2178490Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4({closure#0}+0x

9a) [0x7fd6d481f3ea] std/src/panicking.rs:674

2024-12-31T18:16:43.2179318Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(__rust_end_sho

rt_backtrace<std::panicking::begin_panic_handler::{closure_env#0}, !>+0x9) [0x7fd6d481e4b9] std/sr

c/sys/backtrace.rs:170

2024-12-31T18:16:43.2180155Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(begin_panic_ha

ndler+0x1c) [0x7fd6d481f06c] std/src/panicking.rs:665

2024-12-31T18:16:43.2180809Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(panic_nounwind

_fmt+0x0) [0x7fd6d4459600] core/src/panicking.rs:74

2024-12-31T18:16:43.2181771Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(panic_fmt) (nu

ll):0

2024-12-31T18:16:43.2182304Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(assert_failed_

inner+0x149) [0x7fd6d44599c5]

2024-12-31T18:16:43.2183269Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(assert_failed<

yjit::virtualmem::CodePtr, yjit::virtualmem::CodePtr>+0x0) [0x7fd6d446179d] /rustc/90b35a6239c3d8b

dabc530a6a0816f7ff89a0aaf/library/core/src/panicking.rs:367

2024-12-31T18:16:43.2184088Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(assert_failed<

u8, u8>) (null):0

2024-12-31T18:16:43.2184594Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(0x7fd6d486b2d1

) [0x7fd6d486b2d1]

2024-12-31T18:16:43.2185322Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(to_vec<u8, all

oc::alloc::Global>) /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/alloc/src/slice.rs:159

2024-12-31T18:16:43.2186190Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(to_vec<u8, all

oc::alloc::Global>) /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/alloc/src/slice.rs:108

2024-12-31T18:16:43.2187083Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(to_vec_in<u8, 

alloc::alloc::Global>) /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/alloc/src/slice.rs:

502

2024-12-31T18:16:43.2187910Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(to_vec<u8>) /r

ustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/alloc/src/slice.rs:477

2024-12-31T18:16:43.2188700Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(to_owned<u8>) 

/rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/alloc/src/slice.rs:885

2024-12-31T18:16:43.2189475Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(to_owned) /rus

tc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/alloc/src/str.rs:211

2024-12-31T18:16:43.2190376Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(call_once<fn(&

str) -> alloc::string::String, (&str)>) /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/co

re/src/ops/function.rs:250

2024-12-31T18:16:43.2191245Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(format) /rustc

/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/alloc/src/fmt.rs:642

2024-12-31T18:16:43.2192164Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(gen_leave) /ru

stc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/library/alloc/src/macros.rs:128

2024-12-31T18:16:43.2193181Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(gen_single_blo

ck+0xf65) [0x7fd6d4832215] yjit/src/codegen.rs:1387

2024-12-31T18:16:43.2193838Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(gen_block_seri

es_body+0x15d) [0x7fd6d487ab9a] yjit/src/core.rs:3129

2024-12-31T18:16:43.2194477Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(gen_block_seri

es) yjit/src/core.rs:3066

2024-12-31T18:16:43.2195134Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(branch_stub_hi

t_body+0x46f) [0x7fd6d487cacf] yjit/src/core.rs:3604

2024-12-31T18:16:43.2195817Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4({closure#0}+0x

d) [0x7fd6d4898162] yjit/src/core.rs:3493

2024-12-31T18:16:43.2196586Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(with_compile_t

ime<yjit::core::branch_stub_hit::{closure#0}::{closure_env#0}, *const u8>) yjit/src/stats.rs:1084

2024-12-31T18:16:43.2197308Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4({closure#0}+0x

14) [0x7fd6d48a6ec0] yjit/src/core.rs:3493

2024-12-31T18:16:43.2198183Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(do_call<yjit::

core::branch_stub_hit::{closure_env#0}, *const u8>) /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aa

f/library/std/src/panicking.rs:557

2024-12-31T18:16:43.2199241Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(try<*const u8,

 yjit::core::branch_stub_hit::{closure_env#0}>) /rustc/90b35a6239c3d8bdabc530a6a0816f7ff89a0aaf/li
brary/std/src/panicking.rs:520

2024-12-31T18:16:43.2200280Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(catch_unwind<y

jit::core::branch_stub_hit::{closure_env#0}, *const u8>) /rustc/90b35a6239c3d8bdabc530a6a0816f7ff8

9a0aaf/library/std/src/panic.rs:358

2024-12-31T18:16:43.2201646Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(with_vm_lock<y

jit::core::branch_stub_hit::{closure_env#0}, *const u8>) yjit/src/cruby.rs:688

2024-12-31T18:16:43.2202357Z /opt/hostedtoolcache/Ruby/3.4.1/x64/lib/libruby.so.3.4(branch_stub_hi

t+0x5c) [0x7fd6d488074c] yjit/src/core.rs:3492

2024-12-31T18:16:43.2202742Z [0x7fd69bfe5033]

Associated revisions

Revision dd80d9b089e35729d585bae2f8866c845c48f3b7 - 01/09/2025 12:47 AM - alanwu (Alan Wu)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Revision dd80d9b089e35729d585bae2f8866c845c48f3b7 - 01/09/2025 12:47 AM - alanwu (Alan Wu)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Revision dd80d9b0 - 01/09/2025 12:47 AM - alanwu (Alan Wu)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Revision e9f479d8712f7ecd3802d4438cd44161088d9713 - 01/15/2025 05:16 AM - k0kubun (Takashi Kokubun)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Co-Authored-By: Alan Wu alanwu@ruby-lang.org

Revision e9f479d8712f7ecd3802d4438cd44161088d9713 - 01/15/2025 05:16 AM - k0kubun (Takashi Kokubun)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Co-Authored-By: Alan Wu alanwu@ruby-lang.org

Revision e9f479d8 - 01/15/2025 05:16 AM - k0kubun (Takashi Kokubun)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Co-Authored-By: Alan Wu alanwu@ruby-lang.org

Revision 7c0c2df9b497dbf9c1376a995eebe6d43a00e21b - 01/25/2025 05:51 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) dd80d9b089e35729d585bae2f8866c845c48f3b7: [Backport #20997]

    YJIT: Filter `&` calls from specialized C method codegen

    Evident with the crash reported in [Bug #20997], the C replacement

    codegen functions aren't authored to handle block arguments (nor

    should they because the extra code from the complexity defeats

    optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Revision 7c0c2df9b497dbf9c1376a995eebe6d43a00e21b - 01/25/2025 05:51 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) dd80d9b089e35729d585bae2f8866c845c48f3b7: [Backport #20997]

    YJIT: Filter `&` calls from specialized C method codegen

    Evident with the crash reported in [Bug #20997], the C replacement

    codegen functions aren't authored to handle block arguments (nor

    should they because the extra code from the complexity defeats

    optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Revision 7c0c2df9 - 01/25/2025 05:51 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) dd80d9b089e35729d585bae2f8866c845c48f3b7: [Backport #20997]

    YJIT: Filter `&` calls from specialized C method codegen

    Evident with the crash reported in [Bug #20997], the C replacement

    codegen functions aren't authored to handle block arguments (nor

    should they because the extra code from the complexity defeats

    optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Revision 294aef53b8c988f605001e4555d9532cefe8806d - 02/14/2025 01:46 AM - alanwu (Alan Wu)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Revision 294aef53b8c988f605001e4555d9532cefe8806d - 02/14/2025 01:46 AM - alanwu (Alan Wu)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

Revision 294aef53 - 02/14/2025 01:46 AM - alanwu (Alan Wu)

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

History

#1 - 01/09/2025 12:41 AM - alanwu (Alan Wu)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4: UNKNOWN to 3.1: DONTNEED, 3.2: REQUIRED, 3.3: REQUIRED,

3.4: REQUIRED

Thanks for the report! Everything being available rubygems helped with diagnosis. A fix for this should land soon-ish.

For backporters: The underlying issue is present on all versions since 3.2, but the set of methods that trigger the crash is different. The test I wrote

that uses Module#name might not crash on your version in any case, so you may want to not merge the test and take only the fix.

#2 - 01/09/2025 12:44 AM - alanwu (Alan Wu)

- Subject changed from Ruby 3.4 YJIT panic assertion `left == right` failed: leave instruction expects stack size 1, but was: 2 to YJIT panic assertion

`left == right` failed: leave instruction expects stack size 1, but was: 2
#3 - 01/09/2025 12:47 AM - alanwu (Alan Wu)

- Status changed from Open to Closed

Applied in changeset git|dd80d9b089e35729d585bae2f8866c845c48f3b7.

YJIT: Filter & calls from specialized C method codegen

Evident with the crash reported in [Bug #20997], the C replacement

codegen functions aren't authored to handle block arguments (nor

should they because the extra code from the complexity defeats

optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

#4 - 01/15/2025 05:19 AM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: DONTNEED, 3.2: REQUIRED, 3.3: REQUIRED, 3.4: REQUIRED to 3.1: DONTNEED, 3.2: REQUIRED, 3.3: DONE, 3.4:

REQUIRED

Backporting dd80d9b089e35729d585bae2f8866c845c48f3b7 to ruby_3_3 caused a conflict, but successfully resolved and merged it at 

e9f479d8712f7ecd3802d4438cd44161088d9713.

#5 - 01/25/2025 06:34 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: DONTNEED, 3.2: REQUIRED, 3.3: DONE, 3.4: REQUIRED to 3.1: DONTNEED, 3.2: DONE, 3.3: DONE, 3.4:

REQUIRED

ruby_3_2 7c0c2df9b497dbf9c1376a995eebe6d43a00e21b merged revision(s) dd80d9b089e35729d585bae2f8866c845c48f3b7.

#6 - 02/14/2025 01:46 AM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: DONTNEED, 3.2: DONE, 3.3: DONE, 3.4: REQUIRED to 3.1: DONTNEED, 3.2: DONE, 3.3: DONE, 3.4: DONE

ruby_3_4 294aef53b8c988f605001e4555d9532cefe8806d.
